#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl -w
use strict;
use PureMessage::Service;
use PureMessage::Manager::Request qw($REQUEST %in);
use PureMessage::Manager::Lang qw(&text);
use PureMessage::Manager::Response::Services;
my $response = $REQUEST->get_response(
    'PureMessage::Manager::Response::Services',
    stderr_to_stdout => 1);

$response->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_sched");
$response->title(text('scheduler_index_title'));

my $scheduler;
foreach (PureMessage::Service->Available()) {
    $scheduler = $_ if $_->type eq "scheduler";
}

unless ($scheduler) {
    $response->print_notification(text('scheduler_not_available'));
    $response->send;
    exit;
}

eval {
    if ($REQUEST->query('restart')) {
	$scheduler->restart;
	$response->print_notification(text('scheduler_restarted'));
	sleep 1;
    }

    if ($REQUEST->query('start')) {
	$scheduler->start;
	$response->print_notification(text('scheduler_started'));
	sleep 1;
    }

    if ($REQUEST->query('stop')) {
	$scheduler->stop;
	$response->print_notification(text('scheduler_stopped'));
	sleep 1;
    }
};
if ($@) {
    $response->raise_error($@);
}

my $status = $scheduler->status;
$status->{status} = $status->{running} ? text('status_running') : 
    text('status_stopped');
    
my @buttons;
push(@buttons, {
	type => 'icon', 
	icon => 'start',
	href => 'index.cgi?start=1',
	text => text('start'),
	alt => text('start'),
    }) unless $scheduler->running;
    
push(@buttons, {
	type => 'icon', 
	icon => 'restart',
	href => 'index.cgi?restart=1',
	text => text('restart'),
	alt => text('restart'),
    }) if $scheduler->running;

push(@buttons, {
	type => 'icon', 
	icon => 'stop',
	href => 'index.cgi?stop=1',
	text => text('stop'),
	alt => text('stop'),
    }) if $scheduler->running;

#push(@buttons, {
#	type => 'icon', 
#	icon => 'edit',
#	href => 'edit.cgi', 
#	text => text('edit'),
#	alt => text('edit'),
#    });
#
my %state;
my $tb = $response->ToolBar(
    buttons => [\@buttons], 
    state   => \%state,
    name    => 'tb',
);

# The Form widget's data keys and form labels must match
my $fields = [
    text('scheduler_lbl_status'),
    text('scheduler_lbl_pid'),
];

my $formdata = {
    text('scheduler_lbl_status')      => $status->{status},
    text('scheduler_lbl_pid')         => $status->{pid},
};

my $f = $response->Form(
    name    => 'status_page',
    data    => $formdata,
    fields  => $fields, 
    toolbar => $tb,
    columns => 2,
    title   => text('scheduler_service_status'),
    action  => 'index.cgi',
    );

$response->add_part($f, 'body_form');
$response->send;

