package PureMessage::Scheduler::Handler;
use strict;
use Carp;

our %handlers = (
    'class' => "PureMessage::Scheduler::Handler::class",
    'exec'  => "PureMessage::Scheduler::Handler::exec",
    'null'  => "PureMessage::Scheduler::Handler::null",
);

# simple handler factory.
sub get_handler {
    my $pkg = shift;
    my %param = @_;

    croak "Event missing required paramter/option 'type'" unless $param{type};
    
    my $c = $handlers{$param{type}};
    croak "Invalid handler '$param{type}'" unless $c;
    
    eval "require $c";
    croak "Invalid handler class for '$param{type}': $@" if $@;
    
    my $rv = eval { $c->new(%param) };
    croak "Failed to construct handler '$param{type}': $@" if $@;
    return $rv;
}

1;
