package PureMessage::Scheduler::Handler::class;
use strict;
use Carp;

sub new {
    my $class = shift;
    my %data = @_;
    croak "Missing required parameter 'action'" unless $data{action};

    my $self = bless \%data, $class;

    eval "require $data{action}";
    croak "Failed to load class $data{action}: $@" if $@;
	
    # XXX object instance should be created in its own process
    # XXX also pass the logger object to new()
    $self->{object} = eval{ $data{action}->new(data => $data{data}) };
    croak "Failed to contruct an object of class $data{action}: $@" if $@;

    return $self;
}

sub run {
    my $self = shift;
    my %opts = @_;

    croak "Missing required parameter 'id'" unless $opts{id};

    $self->_log("DEBUG", 
	"Run the callback for $opts{id}");
    
    eval{ $self->{object}->run(@_) };

    $self->_log("DEBUG", 
	"Returned from the callback for $opts{id}");
    $self->_log("WARNING", 
	"An error occured while calling the 'run' callback for the class " .
	"'$opts{action}': $@") if $@;
    1;
}

sub ready { 1 }

sub _log {
    my $self = shift;
    my ($type, $msg) = @_;
    $self->{logger}->log($type, $msg) if $self->{logger};
}

1;

